#ifndef BOOST_MARSHAL_CALL_HEADER_HPP
#define BOOST_MARSHAL_CALL_HEADER_HPP

namespace boost {
namespace marshal {

struct call_options
{
	enum marshal_options
	{
		no_results,
		completed_only,
		return_only,
//		all_non_const
	};
	enum sync_options
	{
		async,
		sync
	};
	enum exception_options
	{
		no_exception_handling
	};

	marshal_options marshal_option;
	sync_options sync_option;
	exception_options exception_option;

	call_options(marshal_options marshal_option_val = no_results,
		sync_options sync_option_val = async,
		exception_options exception_option_val = no_exception_handling)
		: marshal_option(marshal_option_val),
		sync_option(sync_option_val),
		exception_option(exception_option_val) {}
private:
    friend class boost::serialization::access;

	template<class Archive>
	void serialize(Archive &archive, const unsigned int version)
	{
		archive & marshal_option;
		archive & sync_option;
		archive & exception_option;
	}
};

} // namespace marshal
} // namespace boost

#endif // BOOST_MARSHAL_CALL_HEADER_HPP