template<typename Signature, typename ArchivePair>
class call<Signature, ArchivePair,
	typename enable_if_c<boost::function_traits<Signature>::arity==BOOST_ARITY_NUM_ARGS>::type,
	BOOST_ARITY_ENABLE_DISABLE_VOID>
	: public call_base
{
	BOOST_ARITY_STORABLE_TYPES(Signature)
	BOOST_ARITY_TYPES(Signature)
public:
	call(BOOST_ARITY_TYPE_PARMS)
	{
		set(BOOST_PP_ENUM_SHIFTED_PARAMS(BOOST_ARITY_NUM_ARGS_INC,a));
	}
//	call() {}
	void set(BOOST_ARITY_TYPE_PARMS)
	{
		call_base::reset();
		params = detail::serialize<ArchivePair,Signature>
			(BOOST_PP_ENUM_SHIFTED_PARAMS(BOOST_ARITY_NUM_ARGS_INC,a));
	}
	void reset()
	{
		call_base::reset();
	}
#ifdef BOOST_ARITY_NON_VOID_RETURN_TYPE
	typename boost::call_traits<BOOST_ARITY_STORABLE_RESULT_TYPE>::const_reference
		return_val() const {return return_val_;}
#endif
protected:
	virtual const std::string &parameters() const {return params;}
	virtual void result_string(const std::string &str, const call_options &options)
	{
		std::stringstream stream(str, std::ios::in | std::ios::out | std::ios::binary);
		typename ArchivePair::iarchive_type archive(stream);
#ifdef BOOST_ARITY_NON_VOID_RETURN_TYPE
		if (options.marshal_option >= call_options::return_only)
			archive & return_val_;
#endif
	};
private:
	std::string params;
#ifdef BOOST_ARITY_NON_VOID_RETURN_TYPE
	BOOST_ARITY_STORABLE_RESULT_TYPE return_val_;
#endif
};
