#ifndef BOOST_MARSHAL_THREADED_SERVICE_HPP
#define BOOST_MARSHAL_THREADED_SERVICE_HPP

#include <boost/asio.hpp>
#include <boost/thread.hpp>
#include <boost/bind.hpp>

namespace boost {
namespace marshal {
namespace detail {

class threaded_service
{
protected:
	threaded_service() : t(0), work(service) {}
	~threaded_service()
	{
		service.stop();
		if (t)
		{
			t->join();
			delete t;
		}
	}
	void start_service_thread()
	{
		t = new boost::thread(boost::bind(&threaded_service::service_thread, this));
	}
	void service_thread()
	{
		try
		{
			service.run();
		}
		catch (std::exception& e)
		{
			std::cerr << e.what() << std::endl;
		}
	}

	boost::asio::io_service service;
	boost::asio::io_service::work work;
	boost::thread *t;
};

} // namespace detail
} // namespace marshal
} // namespace boost

#endif