#ifndef BOOST_MARSHAL_FUNCTION_HPP
#define BOOST_MARSHAL_FUNCTION_HPP

#include <boost/marshal/binary_archive.hpp>
#include <boost/marshal/call_options.hpp>
#include <sstream>

namespace boost {
namespace marshal {
namespace detail {

template<typename ArchivePair = binary_archive>
class function
{
public:
	virtual void call(const boost::marshal::call_options &options,
		typename ArchivePair::iarchive_type &params,
		typename ArchivePair::oarchive_type *results = 0) {};
};

} // namespace detail
} // namespace marshal
} // namespace boost

#endif // BOOST_MARSHAL_FUNCTION_HPP