#ifndef BOOST_MARSHAL_MARSHALED_HPP
#define BOOST_MARSHAL_MARSHALED_HPP

#include <boost/marshal/config.hpp>
#include <boost/detail/arity.hpp>
#include <boost/function.hpp>
#include <boost/marshal/function.hpp>
#include <boost/utility/enable_if.hpp>

namespace boost {
namespace marshal {
namespace detail {

template<typename Signature, typename ArchivePair, int Arity, typename Enable=void>
class marshaled_impl;

#define BOOST_ARITY_SEPARATE_VOID_RETURN
#define BOOST_ARITY_ITERATION_PARAMS \
	(3,(0,BOOST_MARSHAL_MAX_ARGS,<boost/marshal/detail/marshaled_template.hpp>))
#include <boost/detail/arity_iterate.hpp>
#undef BOOST_ARITY_ITERATION_PARAMS
#undef BOOST_ARITY_SEPARATE_VOID_RETURN

} // namespace detail

template<typename Signature, typename ArchivePair = binary_archive>
class marshaled : public detail::marshaled_impl<Signature, ArchivePair, boost::function_traits<Signature>::arity>
{
public:
	marshaled(const boost::function<Signature> &f)
		: detail::marshaled_impl<Signature, ArchivePair, boost::function_traits<Signature>::arity>(f)
	{}
};

} // namespace marshal
} // namespace boost

#endif // BOOST_MARSHAL_MARSHALED_HPP